//Adds building interaction events to projectiles. I kept it in its own file because quite frankly this kind of sucks.
//We probably need a "building" parent object, although I was too lazy to make one this time around.
//Maybe next time.

/* ROCKET */
object_event_clear(Rocket,ev_other,ev_user5);
object_event_add(Rocket,ev_other,ev_user5,'
    {  
    if(characterHit.id != ownerPlayer.object)
    {
        if(exploded)
            exit;
        else
            exploded = true;
        if(characterHit != -1) {
            if(characterHit.team != team || characterHit.id == ownerPlayer.object and !characterHit.ubered )
            {
                execute_file( damageAutoBetter, ownerPlayer, characterHit, hitDamage );
                if object_is_ancestor(characterHit.object_index, Character)
                {
                    if (characterHit.lastDamageDealer != ownerPlayer and characterHit.lastDamageDealer != characterHit.player)
                    {
                        characterHit.secondToLastDamageDealer = characterHit.lastDamageDealer;
                        characterHit.alarm[4] = characterHit.alarm[3]
                    }
                    characterHit.alarm[3] = ASSIST_TIME;
                }
                characterHit.lastDamageDealer = ownerPlayer;
                characterHit.lastDamageSource = weapon;
            }
        }
        instance_create(x,y,Explosion);
        playsound(x,y,ExplosionSnd);
        
        with (Character) {
            if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.ownerPlayer.object and place_meeting(x, y+1, Obstacle))){
                var rdir, vectorfactor;
                rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
                vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
                    continue;
                motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
                if(!ubered and hp > 0)
                {
                    if (other.team != team) or (id==other.ownerPlayer.object)
                    {
                        damageCharacter( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                        
                        if(id == other.ownerPlayer.object and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer)
                            lastDamageSource = FINISHED_OFF_GIB;
                        else 
                        {
                            if (lastDamageDealer != other.ownerPlayer && lastDamageDealer != player){
                                secondToLastDamageDealer = lastDamageDealer;
                                alarm[4] = alarm[3]
                            }
                            if (other.ownerPlayer != id)
                                alarm[3] = ASSIST_TIME;
                            lastDamageDealer = other.ownerPlayer;
                            lastDamageSource = other.weapon;
                        }
                        cloakAlpha = max(cloakAlpha, 0.3);
                        cloakFlicker = true;
                        alarm[7] = 3;
                    }
                    if id==other.ownerPlayer.object and other.team == team {
                        moveStatus = 1;
                        speed*=1.06;
                    }else if other.team == team and (id!=other.ownerPlayer.object){
                        moveStatus = 4;
                            if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(distance_to_object(other)/other.blastRadius));
                            speed*=1.3;
                        }
                    } else {
                        moveStatus = 2;
                        if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(distance_to_object(other)/other.blastRadius));
                            speed*=1.3;
                        }
                    }
                    if(global.gibLevel > 0) {
                        if (id==other.ownerPlayer.object) or (other.team!=team) {
                            repeat(3) {
                                var blood;
                                blood = instance_create(x,y,Blood);
                                blood.direction = point_direction(other.x,other.y,x,y)-180;
                            }
                        }
                    }
                }
            }
        }

        with (Sentry) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team)
                {
                    damageSentry( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }
        with (Dispenser) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team)
                {
                    damageSentry( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }
		with (TeleporterEntrance) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team)
                {
                    damageSentry( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }	
		with (TeleporterExit) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team)
                {
                    damageSentry( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }	
        
        with (Generator) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team)
                {
                    damageGenerator( other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)) );
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }
        
        with (DeadGuy) {
          if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
          }
        }
        
        with (Gib) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
                rotspeed=random(151)-75;
            }
        }
    
        with(Mine) {
            if (distance_to_object(other) < other.blastRadius*0.66 and (other.team != team or other.ownerPlayer == ownerPlayer)){
                event_user(2);
            }
        }
        
        with(LooseSheet) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
            }
        }
        
        with(Bubble) {
            if (distance_to_object(other) < other.blastRadius*0.66){
                alarm[0]-=200;
            }    
        }

        instance_destroy();
    }
}')
object_event_add(Rocket,ev_collision,Dispenser,'
if(team != other.team) {
    characterHit=other;
    event_user(5);
}
')
object_event_add(Rocket,ev_collision,TeleporterEntrance,'
if(team != other.team) {
    characterHit=other;
	event_user(5);
}

')
object_event_add(Rocket,ev_collision,TeleporterExit,'
if(team != other.team) {
    characterHit=other;
    event_user(5);
}
')

/* SHOT */
object_event_add(Shot,ev_collision,Dispenser,'
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();

if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}')
object_event_add(Shot,ev_collision,TeleporterEntrance,'
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();

if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}')
object_event_add(Shot,ev_collision,TeleporterExit,'
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();

if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}')

/* STAB */
object_event_add(StabMask,ev_collision,Dispenser,'
if(other.team != team)
{
    if(!collision_line(x,y-12,other.x,other.y,Obstacle,true,true)) and (!collision_line(x,y-12,other.x,other.y,TeamGate,true,true) and (!collision_line(x,y-12,other.x,other.y,BulletWall,true,true)))
    {
        damageSentry(ownerPlayer, other.id, hitDamage);
        other.lastDamageDealer = ownerPlayer;
        other.lastDamageSource = weapon;
        
        numKills += 1;
        if numKills >= maxKills
            instance_destroy();
    }
    else
        alarm[0] = 1;
}')
object_event_add(StabMask,ev_collision,TeleporterEntrance,'
if(other.team != team)
{
    if(!collision_line(x,y-12,other.x,other.y,Obstacle,true,true)) and (!collision_line(x,y-12,other.x,other.y,TeamGate,true,true) and (!collision_line(x,y-12,other.x,other.y,BulletWall,true,true)))
    {
        damageSentry(ownerPlayer, other.id, hitDamage);
        other.lastDamageDealer = ownerPlayer;
        other.lastDamageSource = weapon;
        
        numKills += 1;
        if numKills >= maxKills
            instance_destroy();
    }
    else
        alarm[0] = 1;
}')
object_event_add(StabMask,ev_collision,TeleporterExit,'
if(other.team != team)
{
    if(!collision_line(x,y-12,other.x,other.y,Obstacle,true,true)) and (!collision_line(x,y-12,other.x,other.y,TeamGate,true,true) and (!collision_line(x,y-12,other.x,other.y,BulletWall,true,true)))
    {
        damageSentry(ownerPlayer, other.id, hitDamage);
        other.lastDamageDealer = ownerPlayer;
        other.lastDamageSource = weapon;
        
        numKills += 1;
        if numKills >= maxKills
            instance_destroy();
    }
    else
        alarm[0] = 1;
}')

/* BUBBLE */
object_event_add(Bubble, ev_collision, Dispenser, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(Bubble, ev_collision, TeleporterEntrance, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(Bubble, ev_collision, TeleporterExit, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')

/* BLADE */
object_event_add(BladeB, ev_collision, Dispenser, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(BladeB, ev_collision, TeleporterEntrance, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(BladeB, ev_collision, TeleporterExit, '
if(other.team != team)
{
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')

/* FLAMING PROJECTILE (FLAMES AND FLARES) */
object_event_add(BurningProjectile, ev_collision, Dispenser, '
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(BurningProjectile, ev_collision, TeleporterEntrance, '
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(BurningProjectile, ev_collision, TeleporterExit, '
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')

/* MINES */
object_event_add(Mine, ev_create, 0, '
checked_explosion_buildings = false;
')
object_event_add(Mine, ev_collision, Dispenser, '
if(team != other.team)
{
    speed = 0;
    stickied = true;
}
')
object_event_add(Mine, ev_collision, TeleporterEntrance, '
if(team != other.team)
{
    speed = 0;
    stickied = true;
}
')
object_event_add(Mine, ev_collision, TeleporterExit, '
if(team != other.team)
{
    speed = 0;
    stickied = true;
}
')

object_event_add(Mine, ev_other, ev_user2, '
if checked_explosion_buildings exit;
with (Dispenser)
    {
        if (distance_to_object(other) < other.blastRadius) and (team != other.team)
        { 
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold)
                continue;
            damageSentry(other.ownerPlayer, id, other.explosionDamage*3/2*(1-(distance_to_object(other)/other.blastRadius)));
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = DAMAGE_SOURCE_MINEGUN;
        }   
    }
with (TeleporterEntrance)
    {
        if (distance_to_object(other) < other.blastRadius) and (team != other.team)
        { 
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold)
                continue;
            damageSentry(other.ownerPlayer, id, other.explosionDamage*3/2*(1-(distance_to_object(other)/other.blastRadius)));
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = DAMAGE_SOURCE_MINEGUN;
        }   
    }
with (TeleporterExit)
    {
        if (distance_to_object(other) < other.blastRadius) and (team != other.team)
        { 
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold)
                continue;
            damageSentry(other.ownerPlayer, id, other.explosionDamage*3/2*(1-(distance_to_object(other)/other.blastRadius)));
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = DAMAGE_SOURCE_MINEGUN;
        }   
    }
checked_explosion_buildings = true;	
')

/* NEEDLES */
object_event_add(Needle,ev_collision, Dispenser, '
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(Needle,ev_collision, TeleporterEntrance, '
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')
object_event_add(Needle,ev_collision, TeleporterExit, '
gunSetSolids();
if (!place_free(x, y)) 
{
    instance_destroy();
    gunUnsetSolids();
    exit;
}
gunUnsetSolids();
if(other.team != team) {
    damageSentry(ownerPlayer, other.id, hitDamage);
    other.lastDamageDealer = ownerPlayer;
    other.lastDamageSource = weapon;
    instance_destroy();
}
')

/* SENTRY TURRET */
object_event_clear(SentryTurret, ev_step, ev_step_end); // I have to clear this :'(
object_event_add(SentryTurret, ev_step, ev_step_end,'
var targetQueue, testDist, playercheck, targetAngle, obscured, rotateoffset;

if(ownerPlayer.sentry)
{
    x = ownerPlayer.sentry.x;
    y = ownerPlayer.sentry.y;
}
else
{
    instance_destroy();
    exit;
}

if(((direction+270) mod 360)>180) {
    image_xscale=1;
    image_angle = direction;
} else {
    image_xscale=-1;
    image_angle = direction+180;
}

nearestTarget = noone;
targetQueue = ds_priority_create();

// Build a queue of potential targets
with(Character) {
    testDist = distance_to_object(other);
    if(!cloak && testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(Sentry) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(Dispenser) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(TeleporterEntrance) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(TeleporterExit) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

gunSetSolids();
while(!nearestTarget && !ds_priority_empty(targetQueue)) {
    playercheck = ds_priority_delete_min(targetQueue);
    targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
    if((targetAngle <= 45 || targetAngle >= 315 || (targetAngle >= 135 && targetAngle <= 225) || place_meeting(x,y,playercheck)) 
        && playercheck.team != team 
        && playercheck.hp > 0
        && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
            var setupGateCheck, blockedBySetupGate;
            setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
            blockedBySetupGate = true;
            if (setupGateCheck<0) { blockedBySetupGate = false; }
            else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
            if (!blockedBySetupGate) {
                // Target looks valid, but it might be obscured by a sentry.
                // That has to be tested individually because we have to exclude both this sentry and the target
                // from the collision check
                obscured = false;
                with(Sentry) {
                    if(!obscured && id != other.ownerPlayer.sentry && id != playercheck && collision_line(other.x,other.y,playercheck.x,playercheck.y,id,false,false)>=0) {
                        obscured = true;
                    }
                }
                if(!obscured) {
                    nearestTarget = playercheck;
                }
            }
        }
}
ds_priority_destroy(targetQueue);

if(!nearestTarget) {
    noticedTarget = true;
    if(image_xscale>0)
        direction = 0;
    else
        direction = 180;
        
    if image_xscale != startDirection {
        rotating=true;
    }
} else {
    with(Spy) {
        if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
            other.nearestTarget = id;
        }
    }
    
    if(nearestTarget.x < x && image_xscale == 1) {
        rotating=true;
    } else if(nearestTarget.x > x && image_xscale == -1) {
        rotating=true;
    }    
        
    if (noticedTarget == true) {
        playsound(x,y,SentryAlert);
        readyToShoot = false;
        alarm[0] = refireTime*2 / global.delta_factor;
    }    
    
    noticedTarget = false;
    
    if(readyToShoot && (rotating == false)) {
        direction = point_direction(x,y,nearestTarget.x,nearestTarget.y);
        
        // Prevent the turret from turning too high even if it is shooting in that direction.
        // This hides the exception to the angle restriction that occurs when a player is standing
        // directly on the sentry gun. 
        if(direction>=45 and direction<90) direction=45;
        else if(direction>=90 and direction<135) direction=135;
        else if(direction>=225 and direction<270) direction=225;
        else if(direction>=270 and direction<315) direction=315;
        
        playsound(x,y,ShotgunSnd);
        ownerPlayer.sentry.idleTimer = false;
        ownerPlayer.sentry.alarm[5] = 30 / global.delta_factor;
        
        if(nearestTarget.ubered == 0) {
            execute_file(damageAutoBetter,ownerPlayer, nearestTarget, hitDamage);
            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                }
            }
            nearestTarget.alarm[3] = ASSIST_TIME;
            nearestTarget.lastDamageDealer = ownerPlayer;
            nearestTarget.lastDamageSource = DAMAGE_SOURCE_SENTRYTURRET;
            if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
            {
                blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                blood.direction = direction-180;
                dealFlicker(nearestTarget);
            }
        }
        shooting=true;
        readyToShoot=false;
        alarm[0]=refireTime / global.delta_factor;
    }
}
gunUnsetSolids();

if(rotating) {
    rotateindex += 0.3 * global.delta_factor;
    if(rotateindex >= rotateend) {
        image_xscale = -image_xscale;
        direction += 180;
        rotating = false;
        rotateindex = rotatestart;
    }
}')